use std::collections::HashMap;

enum Query {
    Pull {
        name: String,
        version: Option<u128>,
        tags: Vec<String>
    },
    Push {
        _data: Vec<u8>
    }
}

struct Request {
    version: u32,
    id: String,
    token: Option<String>,
    query: HashMap<String, Query>
}

struct DataErrorDetails {
    actor: String,
    detailed_cause: String,
    recovery_options: Vec<String>,
}

struct DataError {
    name: String,
    cause: Option<String>,
    details: Option<DataErrorDetails>
}

enum Data {
    Pull {
        _data: Option<Vec<u8>>,
    }
}

struct Response {
    version: u32,
    id: String,
    reply_to: String,
    errors: HashMap<String, DataError>,
    data: HashMap<String, Data>
}